# -*- coding: utf-8 -*-
#
# Copyright 2012 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.

"""Success page UI."""

from ubuntu_sso.qt.gui import SSOWizardPage


class SuccessPage(SSOWizardPage):
    """Page used to display success message."""

    def __init__(self, ui, *args, **kwargs):
        super(SuccessPage, self).__init__(ui, *args, **kwargs)
        self.next = -1
